/*
 * cdlbasedefs.H:
 *
 *    Here, we put definitions needed by the classes generated by CDL.
 *
 * cdlbasedefs.H,v 1.4 1994/04/07 19:30:52 gjb Exp
 */

    /*********************************************************************
    Copyright (C) 1993-1994 by Citibank, N.A., all rights reserved.

    Permission to use, copy, modify and distribute this software and its 
    documentation for any purpose and without fee, except possible 
    redistribution costs, is hereby granted, provided that (1) the above 
    copyright notice appears in all copies and (2) both that copyright-
    notice and this permission-notice appear in supporting documentation and 
    (3) the name of Citibank, N.A. is not used in advertising or publicity 
    pertaining to distribution of the software without specific and written 
    prior permission of Citibank, N.A.

    The Software is provided "as is."  Citibank, N.A. disclaims all 
    warranties, express or implied, including but not limited to warranties 
    of suitability, merchantability and fitness for any purpose.  In no 
    event shall Citibank, N.A. be responsible for any loss of use, data or 
    profit or for any other special, indirect, incidental or consequential 
    damages, neither in an action of contract nor in an action of tort, 
    arising out of or in connection with the use or performance of this 
    software.
    *********************************************************************/


#ifndef CDL_BASE_DEFS_H
#define CDL_BASE_DEFS_H

#ifdef __cplusplus
extern "C"
{
#include <pthread.h>
}
#endif

#ifndef CDL_DEFINED_BOOLEAN
typedef int Boolean;
#  define CDL_DEFINED_BOOLEAN
#  ifndef true
#    define true 1
#    define false 0
#  endif
#endif

typedef enum { READ, WRITE, LAZY, BRACKET, NONE } CDLReadLock;
typedef enum { CLUSTERED, SEQUENTIAL, RELATIVE, HASHED } CDLFileType;
typedef enum { FORWARDS, BACKWARDS, DEFAULT } CDLIndexDir;
typedef enum { NEXT, PREVIOUS, CURRENT } CDLRecordDir;

extern const int CDLId;		/* An objtran application ID */

/* Flags for file opening modes */
extern const int CDL_EXCLUSIVE_OPEN;
extern const int CDL_NONTRANSACTIONAL_OPEN;
extern const int CDL_LONG_TIMEOUTS;

#ifdef __cplusplus
#include <cdl/cdlerrors.H>
#endif

#endif
