    /*********************************************************************
    Copyright (C) 1993 by Citibank, N.A., all rights reserved.

    Permission to use, copy, modify and distribute this software and its 
    documentation for any purpose and without fee, except possible 
    redistribution costs, is hereby granted, provided that (1) the above 
    copyright notice appears in all copies and (2) both that copyright-
    notice and this permission-notice appear in supporting documentation and 
    (3) the name of Citibank, N.A. is not used in advertising or publicity 
    pertaining to distribution of the software without specific and written 
    prior permission of Citibank, N.A.

    The Software is provided "as is."  Citibank, N.A. disclaims all 
    warranties, express or implied, including but not limited to warranties 
    of suitability, merchantability and fitness for any purpose.  In no 
    event shall Citibank, N.A. be responsible for any loss of use, data or 
    profit or for any other special, indirect, incidental or consequential 
    damages, neither in an action of contract nor in an action of tort, 
    arising out of or in connection with the use or performance of this 
    software.
    *********************************************************************/


#ifndef YQbaseDEFINED
#define YQbaseDEFINED

/* common definitions for generated YQ... classes */

extern "C"
{
#include <pthread.h>
}
#include <String.h>
#include <Block.h>
#include <iostream.h>
#include <cdl/cdldefs.H>
#include <cdl/cdlerrors.H>
#include <objdce/error.H>
#include <objtran/transaction.H>

extern "C"
{
#include <rqs/rqs.h>
}

class YQbase
{
public:
  friend ostream & operator<<(ostream &o, const YQbase &);
  YQbase(const String & ApplicationName);

  enum DeleteOption { Delete, Orphan };
  enum CursorPolicy{  NoLocking = rqs_noLocking, 
		      OperationLocking = rqs_operationLocking, 
		      CursorStability = rqs_cursorStability,
		      TranRepeatability = rqs_tranRepeatability};
  enum ElementLockMode{	NoLock = rqs_noLock, 
			ReadLock = rqs_readLock, 
			UpgradeLock = rqs_upgradeLock, 
			WriteLock = rqs_writeLock};
  static const char* DefaultServer;
  const String aName; /* apllication portion of concatenated name */
  rqs_status_t RqsStatusValue;
private:
  Boolean RetryError(const rqs_status_t err) const;
  Boolean NoAbort(CDLStatus err) const;
protected:
  CDLStatus CheckError(const int msgNum, const rqs_status_t err,
		       Transaction& tran, 
		       ErrorLevels::ReportingLevels level) const;
  CDLStatus ThrowError(const int msgNum, CDLStatus err,
		       Transaction& tran, 
		       ErrorLevels::ReportingLevels level) const;
  CDLStatus ConvertStatus(const rqs_status_t err) const;
};

#endif
