    /*********************************************************************
    Copyright (C) 1993 by Citibank, N.A., all rights reserved.

    Permission to use, copy, modify and distribute this software and its 
    documentation for any purpose and without fee, except possible 
    redistribution costs, is hereby granted, provided that (1) the above 
    copyright notice appears in all copies and (2) both that copyright-
    notice and this permission-notice appear in supporting documentation and 
    (3) the name of Citibank, N.A. is not used in advertising or publicity 
    pertaining to distribution of the software without specific and written 
    prior permission of Citibank, N.A.

    The Software is provided "as is."  Citibank, N.A. disclaims all 
    warranties, express or implied, including but not limited to warranties 
    of suitability, merchantability and fitness for any purpose.  In no 
    event shall Citibank, N.A. be responsible for any loss of use, data or 
    profit or for any other special, indirect, incidental or consequential 
    damages, neither in an action of contract nor in an action of tort, 
    arising out of or in connection with the use or performance of this 
    software.
    *********************************************************************/


#ifndef YQNAMEDEFINED
#define YQNAMEDEFINED
/* manage the manipulation of yq names.  yq names consist of an application
 * name followed by an underscore ``_'' followed by a type name.  This class
 * provides for the construction and decomposition of these names
 */
extern "C"
{
#include <pthread.h>
}
#include <String.h>
class YQname
    {
public:
	YQname();
	YQname(const String & ApplicationName, const String & TypeName);
	YQname(const YQname & src);
	virtual ~YQname();
	YQname & operator=(const YQname & src);
	friend ostream & operator<<(ostream & o, const YQname & src);
	int operator==(const YQname & src) const;
	int operator!=(const YQname & src) const;
	int operator<(const YQname & src) const;
	int operator>(const YQname & src) const;
	const String ApplicationName() const;
	const String TypeName() const;
	const String & FullName() const;
private:
	String fName;	/* Full Name */
    };
#endif
