/*
 * Sut:
 *    The system under test, hence the cryptic and silly name. This does
 * the actual processing of the actual transactions.
 *
 */

#ifndef TPC_SUT_H
#define TPC_SUT_H

#include <objtran/transerver.H>
#include <tpcfiles_cdl.H>
extern "C"
{
#include <trpc/trpc.h>
}

class SFSAccountFile;
class SFSBranchFile;
class SFSTellerFile;
class SFSHistoryFile;
class TranBinding;
class ServerLoginContext;

class Sut

{
public:
  Sut(int serverNo);
  virtual ~Sut();
  void Process(handle_t, unsigned long accountID, unsigned long tellerID,
	       unsigned long branchID, idl_hyper_int delta, 
	       idl_hyper_int* newBalance, short* committed);
  void UpdateAccount(trpc_handle_t, unsigned long accountID, 
		     idl_hyper_int delta, idl_hyper_int* newBal);
  void UpdateTeller(trpc_handle_t, unsigned long tellerID, 
		    idl_hyper_int delta, idl_hyper_int* newBal);
  void UpdateBranch(trpc_handle_t, unsigned long branchID, 
		    idl_hyper_int delta, idl_hyper_int* newBal);
  void Read(handle_t, AccountBase* rec, short* committed);
  void ReadBranch(handle_t, BranchBase* rec, short* committed);
  void ReadTeller(handle_t, TellerBase* rec, short* committed);
  static Sut* Instance();
private:
  static Sut* myself;
  ServerLoginContext* context;
  TranServer* server;
  SFSAccountFile* accounts;
  SFSTellerFile* tellers;
  SFSBranchFile* branches;
  SFSHistoryFile* history;
  TranBinding** otherServers;
  int myNo;
};

#endif
