/*
 * CDLConstInfo
 *
 *    This class is just a holder for various information about
 * constants.
 */

    /*********************************************************************
    Copyright (C) 1994 by Citibank, N.A., all rights reserved.

    Permission to use, copy, modify and distribute this software and its 
    documentation for any purpose and without fee, except possible 
    redistribution costs, is hereby granted, provided that (1) the above 
    copyright notice appears in all copies and (2) both that copyright-
    notice and this permission-notice appear in supporting documentation and 
    (3) the name of Citibank, N.A. is not used in advertising or publicity 
    pertaining to distribution of the software without specific and written 
    prior permission of Citibank, N.A.

    The Software is provided "as is."  Citibank, N.A. disclaims all 
    warranties, express or implied, including but not limited to warranties 
    of suitability, merchantability and fitness for any purpose.  In no 
    event shall Citibank, N.A. be responsible for any loss of use, data or 
    profit or for any other special, indirect, incidental or consequential 
    damages, neither in an action of contract nor in an action of tort, 
    arising out of or in connection with the use or performance of this 
    software.
    *********************************************************************/

#include <cdlconstinfo.H>

#ifdef _AIX
#include <Map.c>

#pragma define(Map<Symbol, CDLConstInfo>)
#pragma define(Mapiter<Symbol, CDLConstInfo>)
#endif

Map<Symbol, CDLConstInfo> CDLConstants;

CDLConstInfo::CDLConstInfo()

{
  fType = CDLField::LONG;		// Arbitrary!
  mType = CDLField::NONE;
}

CDLConstInfo::CDLConstInfo(CDLField::FieldType f, 
			   CDLField::ModifierType m,
			   const String& n, const String& v, 
			   Boolean imp)
    : NamedObject(n), value(v)

{
  fType = f;
  mType = m;
  imported = imp;
}

CDLConstInfo::CDLConstInfo(const CDLConstInfo& c)

{
  this->operator = (c);
}

CDLConstInfo& CDLConstInfo::operator = (const CDLConstInfo& c)

{
  NamedObject::operator = (c);
  fType = c.fType;
  mType = c.mType;
  value = c.value;
  imported = c.imported;
  return *this;
}

CDLConstInfo::~CDLConstInfo()

{
}

