/*
 * CDLFileGenerator:
 *
 *    This generator creates the abstract superclasses for the SFS,
 * Oracle and other types of files. These go into the <filename>_cdl_file.H file,
 * with a little (very little) in <filename>_cdl_file.C. This generator
 * also runs the parser in the CDLAuxParser class, and hangs on to a list
 * of the file definitions it generates. These two classes can then access
 * the list of file definitions by getting those objects from this class.
 * 
 * cdlfilegenerator.H,v 1.4 1993/12/03 14:43:05 lcp Exp
 */

    /*********************************************************************
    Copyright (C) 1993 by Citibank, N.A., all rights reserved.

    Permission to use, copy, modify and distribute this software and its 
    documentation for any purpose and without fee, except possible 
    redistribution costs, is hereby granted, provided that (1) the above 
    copyright notice appears in all copies and (2) both that copyright-
    notice and this permission-notice appear in supporting documentation and 
    (3) the name of Citibank, N.A. is not used in advertising or publicity 
    pertaining to distribution of the software without specific and written 
    prior permission of Citibank, N.A.

    The Software is provided "as is."  Citibank, N.A. disclaims all 
    warranties, express or implied, including but not limited to warranties 
    of suitability, merchantability and fitness for any purpose.  In no 
    event shall Citibank, N.A. be responsible for any loss of use, data or 
    profit or for any other special, indirect, incidental or consequential 
    damages, neither in an action of contract nor in an action of tort, 
    arising out of or in connection with the use or performance of this 
    software.
    *********************************************************************/


#ifndef CDL_FILE_GENERATOR_H
#define CDL_FILE_GENERATOR_H

#include <cdlgenerator.H>
#include <objdce/objtranparams.H>

class CDLFileGenerator : public CDLDataGenerator

{
public:
  CDLFileGenerator(const ArgList&);
  virtual ~CDLFileGenerator();
  virtual Boolean Start(const String& fileName);
  virtual Boolean Generate(CDLRecord&, CDLFileDef&);
  virtual Boolean End();
  virtual void DeleteFiles();
private:
  Boolean GenHeader(CDLRecord&, CDLFileDef&);
  Boolean GenMain(CDLRecord&, CDLFileDef&);
  
  ofstream inclFile;
  String mainName;
  String inclName;
};

#endif
