/* 
 * CDLIdlGenerator:
 *
 *    This is a generator that produces an IDL file based on the
 * CDLRecords it is given. It can then optionally run the file through
 * IDL. 
 *
 * cdlidlgenerator.H,v 1.6 1994/04/07 19:25:48 gjb Exp
 */

    /*********************************************************************
    Copyright (C) 1993 by Citibank, N.A., all rights reserved.

    Permission to use, copy, modify and distribute this software and its 
    documentation for any purpose and without fee, except possible 
    redistribution costs, is hereby granted, provided that (1) the above 
    copyright notice appears in all copies and (2) both that copyright-
    notice and this permission-notice appear in supporting documentation and 
    (3) the name of Citibank, N.A. is not used in advertising or publicity 
    pertaining to distribution of the software without specific and written 
    prior permission of Citibank, N.A.

    The Software is provided "as is."  Citibank, N.A. disclaims all 
    warranties, express or implied, including but not limited to warranties 
    of suitability, merchantability and fitness for any purpose.  In no 
    event shall Citibank, N.A. be responsible for any loss of use, data or 
    profit or for any other special, indirect, incidental or consequential 
    damages, neither in an action of contract nor in an action of tort, 
    arising out of or in connection with the use or performance of this 
    software.
    *********************************************************************/


#ifndef CDL_IDL_GENERATOR_H
#define CDL_IDL_GENERATOR_H

#include <cdlgenerator.H>

class CDLIdlGenerator : public CDLGenerator

{
public:
  CDLIdlGenerator(const ArgList&, Boolean nidlMode);
  virtual ~CDLIdlGenerator();
  virtual Boolean Start(const String& fileName);
  virtual Boolean End();
  virtual Boolean Generate(CDLRecord&);
  virtual void DeleteFiles();
  Boolean FindIdl(String& idlNameOut);
  Boolean RunIdl(Boolean makeStubs = true);	// Run IDL on the produced file
private:
  Boolean BuildFieldList(CDLRecord& rec, List<FieldNode>& out);
  Boolean ExpandOneRecord(CDLRecord* rec, const String& name,
			  List<FieldNode>& out);
  Boolean GenEnums();

  String newName;
  String mainName;
  String acfName;
  ofstream acfFile;
  Boolean nidlMode;
};

#endif
  

