/*
 * CDLIndexFieldDef:
 *
 *    This object represents a single field in an index. The field has
 * a name and various attributes.
 *
 * cdlindexfielddef.H,v 1.5 1994/04/07 19:25:54 gjb Exp
 */

    /*********************************************************************
    Copyright (C) 1993 by Citibank, N.A., all rights reserved.

    Permission to use, copy, modify and distribute this software and its 
    documentation for any purpose and without fee, except possible 
    redistribution costs, is hereby granted, provided that (1) the above 
    copyright notice appears in all copies and (2) both that copyright-
    notice and this permission-notice appear in supporting documentation and 
    (3) the name of Citibank, N.A. is not used in advertising or publicity 
    pertaining to distribution of the software without specific and written 
    prior permission of Citibank, N.A.

    The Software is provided "as is."  Citibank, N.A. disclaims all 
    warranties, express or implied, including but not limited to warranties 
    of suitability, merchantability and fitness for any purpose.  In no 
    event shall Citibank, N.A. be responsible for any loss of use, data or 
    profit or for any other special, indirect, incidental or consequential 
    damages, neither in an action of contract nor in an action of tort, 
    arising out of or in connection with the use or performance of this 
    software.
    *********************************************************************/


#ifndef CDL_INDEX_FIELD_DEF_H
#define CDL_INDEX_FIELD_DEF_H

extern "C"
{
#include <pthread.h>
}
#include <iostream.h>
#include <objdce/objtranparams.H>
#include <cdl/cdldefs.H>
#include <cdlindexdef.H>
#include <namedobject.H>

class CDLIndexFieldDef : public NamedObject

{
  friend ostream& operator << (ostream&, const CDLIndexFieldDef&);
public:
  CDLIndexFieldDef();
  CDLIndexFieldDef(const String& name, CDLIndexDir direction,
		   const String& language);
  CDLIndexFieldDef(const CDLIndexFieldDef&);
  virtual ~CDLIndexFieldDef();
  CDLIndexFieldDef& operator = (const CDLIndexFieldDef&);
  CDLIndexDir Direction() const;
  const String& Language() const;
private:
  CDLIndexDir myDir;
  String lang;
};

inline CDLIndexDir CDLIndexFieldDef::Direction() const

{ return myDir; }

inline const String& CDLIndexFieldDef::Language() const

{ return lang; }

#endif
