/*
 * CDLMainParser:
 *
 *    This class parses the main CDL file. It runs the input through
 * cpp, then into the yacc parser. While parsing, it builds a list of 
 * CDLRecord objects. It then passes the objects in turn to each of a series
 * of CDLGenerator subclasses, which spit out the generated code.
 *
 * cdlmainparser.H,v 1.5 1993/12/03 14:43:33 lcp Exp
 */

    /*********************************************************************
    Copyright (C) 1993 by Citibank, N.A., all rights reserved.

    Permission to use, copy, modify and distribute this software and its 
    documentation for any purpose and without fee, except possible 
    redistribution costs, is hereby granted, provided that (1) the above 
    copyright notice appears in all copies and (2) both that copyright-
    notice and this permission-notice appear in supporting documentation and 
    (3) the name of Citibank, N.A. is not used in advertising or publicity 
    pertaining to distribution of the software without specific and written 
    prior permission of Citibank, N.A.

    The Software is provided "as is."  Citibank, N.A. disclaims all 
    warranties, express or implied, including but not limited to warranties 
    of suitability, merchantability and fitness for any purpose.  In no 
    event shall Citibank, N.A. be responsible for any loss of use, data or 
    profit or for any other special, indirect, incidental or consequential 
    damages, neither in an action of contract nor in an action of tort, 
    arising out of or in connection with the use or performance of this 
    software.
    *********************************************************************/


#ifndef CDL_MAIN_PARSER_H
#define CDL_MAIN_PARSER_H

#include <cdlparser.H>
#include <cdl/cdldefs.H>
#include <String.h>
#include <cdlrecord.H>
#include <arglist.H>

class CDLMainParser : public CDLParser

{
public:
  CDLMainParser(const ArgList&);
  virtual ~CDLMainParser();
  Boolean Parse(const String& fileName, 
		List_of_p<CDLGenerator>& generators);
  Boolean AddRecord(CDLRecord*);
  CDLRecord* Find(const String&) const;
private:
  List_of_p<CDLRecord> recordList;
};

#endif
