/* 
 * CDLNidlGenerator:
 *
 *    This is a generator that produces an NIDL file based on the
 * CDLRecords it is given. It can then optionally run the file through
 * NIDL. 
 *
 * cdlnidlgenerator.H,v 1.1 1994/04/19 19:21:13 gjb Exp
 */

    /*********************************************************************
    Copyright (C) 1994 by Citibank, N.A., all rights reserved.

    Permission to use, copy, modify and distribute this software and its 
    documentation for any purpose and without fee, except possible 
    redistribution costs, is hereby granted, provided that (1) the above 
    copyright notice appears in all copies and (2) both that copyright-
    notice and this permission-notice appear in supporting documentation and 
    (3) the name of Citibank, N.A. is not used in advertising or publicity 
    pertaining to distribution of the software without specific and written 
    prior permission of Citibank, N.A.

    The Software is provided "as is."  Citibank, N.A. disclaims all 
    warranties, express or implied, including but not limited to warranties 
    of suitability, merchantability and fitness for any purpose.  In no 
    event shall Citibank, N.A. be responsible for any loss of use, data or 
    profit or for any other special, indirect, incidental or consequential 
    damages, neither in an action of contract nor in an action of tort, 
    arising out of or in connection with the use or performance of this 
    software.
    *********************************************************************/


#ifndef CDL_NIDL_GENERATOR_H
#define CDL_NIDL_GENERATOR_H

#include <cdlgenerator.H>

class CDLNidlGenerator : public CDLGenerator

{
public:
  CDLNidlGenerator(const ArgList&);
  virtual ~CDLNidlGenerator();
  virtual Boolean Start(const String& fileName);
  virtual Boolean End();
  virtual Boolean Generate(CDLRecord&);
  virtual void DeleteFiles();
  Boolean FindNidl(String& nidlNameOut);
  Boolean RunNidl(Boolean makeStubs = true);	// Run NIDL on the produced file
private:
  Boolean GenEnums();

  String newName;
  String mainName;
};

#endif
  

