/*
 * CDLParser:
 *
 *    This is an abstract class that can be used to create parsers. This class
 * simply encapsulates the functionality requred to run a file through cpp
 * and through a yacc-based parser. It is up to subclasses of this class to
 * maintain a list of records or whatever and to write functions so the yacc
 * and lex code can generate this list.
 *
 * cdlparser.H,v 1.6 1994/04/07 19:26:02 gjb Exp
 */

    /*********************************************************************
    Copyright (C) 1993 by Citibank, N.A., all rights reserved.

    Permission to use, copy, modify and distribute this software and its 
    documentation for any purpose and without fee, except possible 
    redistribution costs, is hereby granted, provided that (1) the above 
    copyright notice appears in all copies and (2) both that copyright-
    notice and this permission-notice appear in supporting documentation and 
    (3) the name of Citibank, N.A. is not used in advertising or publicity 
    pertaining to distribution of the software without specific and written 
    prior permission of Citibank, N.A.

    The Software is provided "as is."  Citibank, N.A. disclaims all 
    warranties, express or implied, including but not limited to warranties 
    of suitability, merchantability and fitness for any purpose.  In no 
    event shall Citibank, N.A. be responsible for any loss of use, data or 
    profit or for any other special, indirect, incidental or consequential 
    damages, neither in an action of contract nor in an action of tort, 
    arising out of or in connection with the use or performance of this 
    software.
    *********************************************************************/


#ifndef CDL_GENERIC_PARSER_H
#define CDL_GENERIC_PARSER_H

extern "C"
{
#include <pthread.h>
}
#include <cdl/cdldefs.H>
#include <objdce/objtranparams.H>
#include <String.h>
#include <Path.h>
#include <List.h>
#include <arglist.H>

class CDLGenerator;

class CDLParser

{
protected:
  CDLParser(const ArgList&);
public:
  virtual ~CDLParser();
  Boolean PreProcess(const String& inFile, String& outFile);
  Boolean FindCpp(String& cppNameOut);
protected:
  ArgList cppArgs;
  ArgList origArgs;
};

#endif
