/*
 * CDLRqsGenerator:
 *
 *    This generator produces a subclass of the file class that works 
 * with RQS. 
 *
 * cdlrqsgenerator.H,v 1.4 1994/02/01 22:33:22 gjb Exp
 */

    /*********************************************************************
    Copyright (C) 1993 by Citibank, N.A., all rights reserved.

    Permission to use, copy, modify and distribute this software and its 
    documentation for any purpose and without fee, except possible 
    redistribution costs, is hereby granted, provided that (1) the above 
    copyright notice appears in all copies and (2) both that copyright-
    notice and this permission-notice appear in supporting documentation and 
    (3) the name of Citibank, N.A. is not used in advertising or publicity 
    pertaining to distribution of the software without specific and written 
    prior permission of Citibank, N.A.

    The Software is provided "as is."  Citibank, N.A. disclaims all 
    warranties, express or implied, including but not limited to warranties 
    of suitability, merchantability and fitness for any purpose.  In no 
    event shall Citibank, N.A. be responsible for any loss of use, data or 
    profit or for any other special, indirect, incidental or consequential 
    damages, neither in an action of contract nor in an action of tort, 
    arising out of or in connection with the use or performance of this 
    software.
    *********************************************************************/


#ifndef CDL_RQS_GENERATOR_H
#define CDL_RQS_GENERATOR_H

#include <cdlgenerator.H>
#include <objdce/objtranparams.H>
#include <cdlfield.H>
#include <namedobject.H>
#include <Path.h>
#include <List.h>

class CDLRqsGenerator : public CDLDataGenerator

{
public:
  CDLRqsGenerator(const ArgList&);
  virtual ~CDLRqsGenerator();
  virtual Boolean Start(const String& fileName);
  virtual Boolean Generate(CDLRecord&, CDLFileDef&);
  virtual Boolean End();
  virtual void DeleteFiles();
private:
  Boolean GenField(CDLField&, const String& prefix, 
		   const String& fieldName, int entryNum);
  Boolean GenFieldSpec(CDLField&, const String& prefix, 
		       const String& fieldName, int entryNum);
  Boolean GenIndexField(CDLIndexFieldDef&, const String& pfx, int entryNum);
  Boolean GenSubclasses(CDLRecord&, CDLFileDef&);
#if 0
  Boolean GenModifiers(CDLRecord&, CDLFileDef&);
#endif
  Boolean GenHeader(CDLRecord&, CDLFileDef&);
#if 0
  Boolean GenMain(CDLRecord&, CDLFileDef&);
#endif
  virtual int GetSize(CDLField&) const;
  Boolean BuildFieldList(CDLRecord&, List<FieldNode>& out);
  Boolean ExpandOneRecord(CDLRecord*, const String& name,
                          List<FieldNode>& varFields,
                          List<FieldNode>& nonVarFields);

  ofstream inclFile;
  String mainName;
  String inclName;
};

#endif
