/*
 * cdlsuffixes.H
 *
 *    This file contains the prefixes and suffixes used by the CDL parser
 * when it generates files and symbol names. Perhaps doing this will 
 * keep us from conflicting with such names in the future.
 *
 * cdlsuffixes.H,v 1.4 1994/04/07 19:26:25 gjb Exp
 */

    /*********************************************************************
    Copyright (C) 1993 by Citibank, N.A., all rights reserved.

    Permission to use, copy, modify and distribute this software and its 
    documentation for any purpose and without fee, except possible 
    redistribution costs, is hereby granted, provided that (1) the above 
    copyright notice appears in all copies and (2) both that copyright-
    notice and this permission-notice appear in supporting documentation and 
    (3) the name of Citibank, N.A. is not used in advertising or publicity 
    pertaining to distribution of the software without specific and written 
    prior permission of Citibank, N.A.

    The Software is provided "as is."  Citibank, N.A. disclaims all 
    warranties, express or implied, including but not limited to warranties 
    of suitability, merchantability and fitness for any purpose.  In no 
    event shall Citibank, N.A. be responsible for any loss of use, data or 
    profit or for any other special, indirect, incidental or consequential 
    damages, neither in an action of contract nor in an action of tort, 
    arising out of or in connection with the use or performance of this 
    software.
    *********************************************************************/


#ifndef CDL_SUFFIXES_PREFIXES_H
#define CDL_SUFFIXES_PREFIXES_H

extern const char* const CDLIdlFileSuffix;		// Suffix for IDL files
extern const char* const CDLNidlFileSuffix;		// Suffix for IDL files
extern const char* const CDLAcfFileSuffix;		// .h file from idl
extern const char* const CDLIdlHeaderSuffix;		// .h file from idl
extern const char* const CDLNidlHeaderSuffix;		// .h file from idl
extern const char* const CDLIdlInterfaceSuffix;		// IDL interface name
extern const unsigned int CDLIdlInterfaceMaxLen;	// Max length of above
extern const char* const CDLIdlRecordSuffix;		// IDL struct name
extern const char* const CDLIdlArraySuffix;		// IDL array of structs
extern const char* const CDLCppSourceSuffix;		// C++ source file
extern const char* const CDLCppHeaderSuffix;		// C++ header file
extern const char* const CDLHeaderIfdefSuffix;		// #ifdef for .H file
extern const char* const CDLCppIdlRecordName;		// struct name in class
extern const char* const CDLByteArrayLengthSuffix;	// name of a "length"

// And some path names
extern const char* const CDLDCEIncludes;		// DCE include location
extern const char* const CDLDCEIncludeCmd;		// Command to include 
extern const char* const CDLIdlSearchPath;		// IDL compiler
extern const char* const CDLCppSearchPath;		// Where to find cpp
extern const char* const CDLDefaultTmp;			// Default scratch dir

#endif
