/*
 * mainparsedefs.H
 *
 *    This contains definitions of functions called by the parser code.
 *
 * mainparsedefs.H,v 1.10 1994/04/07 19:26:31 gjb Exp
 */

    /*********************************************************************
    Copyright (C) 1993-1994 by Citibank, N.A., all rights reserved.

    Permission to use, copy, modify and distribute this software and its 
    documentation for any purpose and without fee, except possible 
    redistribution costs, is hereby granted, provided that (1) the above 
    copyright notice appears in all copies and (2) both that copyright-
    notice and this permission-notice appear in supporting documentation and 
    (3) the name of Citibank, N.A. is not used in advertising or publicity 
    pertaining to distribution of the software without specific and written 
    prior permission of Citibank, N.A.

    The Software is provided "as is."  Citibank, N.A. disclaims all 
    warranties, express or implied, including but not limited to warranties 
    of suitability, merchantability and fitness for any purpose.  In no 
    event shall Citibank, N.A. be responsible for any loss of use, data or 
    profit or for any other special, indirect, incidental or consequential 
    damages, neither in an action of contract nor in an action of tort, 
    arising out of or in connection with the use or performance of this 
    software.
    *********************************************************************/


#ifndef MAIN_PARSE_DEFS_H
#define MAIN_PARSE_DEFS_H

#include <cdl/cdldefs.H>
#include <stdio.h>

#define CDL_MAIN_FIELD_LEN 64
#define CDL_MAIN_LONG_FIELD_LEN 4096

#ifdef __cplusplus
extern "C"
{
#include <pthread.h>
}
#include <cdlmainparser.H>
extern void CDLMainSetParser(CDLMainParser*);
extern CDLMainParser* CDLMainGetParser();
extern "C" {

#endif

extern void CDLMainSetName(
#ifdef __STDC__
			   const char* fName
#endif
			 );

extern char* CDLMainGetName(
#if __STDC__
			    void
#endif
			  );

extern void CDLMainAddField (
#ifdef __STDC__
			     const char* fieldMod, const char* fieldType, 
			     const char* fieldName, const char* fieldLen,
			     const char* arraySize
#endif
			   );
extern void CDLMainAddUserField(
#ifdef __STDC__
				const char* recType, const char* fieldName,
				const char* arraySize
#endif
			      );
extern void CDLMainAddEnumField(
#ifdef __STDC__
				const char* enumType, const char* fieldName,
				const char* arrayLen
#endif
			      );
extern void CDLMainAddAmbiguousField(
#ifdef __STDC__
				const char* fieldType, const char* fieldName,
				const char* arrayLen
#endif
			      );
extern void CDLMainSetDocumentation(
#ifdef __STDC__
				    const char* newDocString
#endif
				  );
extern void CDLMainStartRecord(
#ifdef __STDC__
			       const char* recName,
			       Boolean imported
#endif
			     );
extern void CDLMainEndRecord(
#if __STDC__
			     void
#endif
			   );
extern void CDLMainAddConst(
#ifdef __STDC__
			    const char* fieldMod, const char* fieldType,
			    const char* fieldName, const char* fieldValue
#endif
			  );
extern void CDLMainAddEnum(
#ifdef __STDC__
			   const char* enumName, unsigned int lastListPos
#endif
			 );
extern void CDLMainerror(
#ifdef __STDC__
			 char*
#endif 
		       );
extern int CDLMainparse(
#if __STDC__
			void
#endif
		      );

#ifdef __cplusplus
}
#endif

extern int CDLMainCurrentLine;
extern int CDLMaindebug;
extern FILE* CDLMainin;
extern int CDLMainFailed;
extern int CDLMainMakeIdlArray;

#endif
