/*
 * NamedObject:
 *
 *    This is just an object that has a name. It has a function called
 * Name that returns the name, and the name can be set by subclasses.
 * I wrote this because I got sick of writing Name functions for everyone.
 *
 * namedobject.H,v 1.4 1994/04/07 19:26:37 gjb Exp 
 *
 */

    /*********************************************************************
    Copyright (C) 1993 by Citibank, N.A., all rights reserved.

    Permission to use, copy, modify and distribute this software and its 
    documentation for any purpose and without fee, except possible 
    redistribution costs, is hereby granted, provided that (1) the above 
    copyright notice appears in all copies and (2) both that copyright-
    notice and this permission-notice appear in supporting documentation and 
    (3) the name of Citibank, N.A. is not used in advertising or publicity 
    pertaining to distribution of the software without specific and written 
    prior permission of Citibank, N.A.

    The Software is provided "as is."  Citibank, N.A. disclaims all 
    warranties, express or implied, including but not limited to warranties 
    of suitability, merchantability and fitness for any purpose.  In no 
    event shall Citibank, N.A. be responsible for any loss of use, data or 
    profit or for any other special, indirect, incidental or consequential 
    damages, neither in an action of contract nor in an action of tort, 
    arising out of or in connection with the use or performance of this 
    software.
    *********************************************************************/


#ifndef NAMED_OBJECT_H
#define NAMED_OBJECT_H

extern "C"
{
#include <pthread.h>
}
#include <String.h>

class NamedObject

{
public:
  NamedObject();
  NamedObject(const String&);
  NamedObject(const NamedObject&);
  virtual ~NamedObject();
  NamedObject& operator = (const NamedObject&);
  int operator == (const NamedObject&) const;
  int operator < (const NamedObject&) const;
  int operator > (const NamedObject&) const;
  const String& Name() const;
protected:
  String name;
};

inline const String& NamedObject::Name() const

{ return name; }

#endif
