/*
 * sfsparsedefs.H:
 *
 *    These functions are called by the yacc parser for the auxiliary SFS
 * file.
 *
 * sfsparsedefs.H,v 1.5 1994/04/07 19:26:42 gjb Exp
 */

    /*********************************************************************
    Copyright (C) 1993 by Citibank, N.A., all rights reserved.

    Permission to use, copy, modify and distribute this software and its 
    documentation for any purpose and without fee, except possible 
    redistribution costs, is hereby granted, provided that (1) the above 
    copyright notice appears in all copies and (2) both that copyright-
    notice and this permission-notice appear in supporting documentation and 
    (3) the name of Citibank, N.A. is not used in advertising or publicity 
    pertaining to distribution of the software without specific and written 
    prior permission of Citibank, N.A.

    The Software is provided "as is."  Citibank, N.A. disclaims all 
    warranties, express or implied, including but not limited to warranties 
    of suitability, merchantability and fitness for any purpose.  In no 
    event shall Citibank, N.A. be responsible for any loss of use, data or 
    profit or for any other special, indirect, incidental or consequential 
    damages, neither in an action of contract nor in an action of tort, 
    arising out of or in connection with the use or performance of this 
    software.
    *********************************************************************/


#ifndef SFS_PARSE_DEFS_H
#define SFS_PARSE_DEFS_H

#ifdef __cplusplus
extern "C"
{
#endif
#include <pthread.h>
#ifdef __cplusplus
}
#endif

#include <cdl/cdldefs.H>
#include <stdio.h>
#include <cdl/cdlbasedefs.H>

#ifdef __cplusplus
class CDLAuxParser;
extern void CDLSfsSetParser(CDLAuxParser*);
extern void CDLSfsSetName(const char*);
extern CDLAuxParser* CDLSfsGetParser();

extern "C" {
#endif

extern void CDLSfsStartFile(
#ifdef __STDC__			      
			    const char* fileName, const char* recName
#endif
			  );
extern void CDLSfsEndFile(
#if __STDC__
			  void
#endif
			);
extern void CDLSfsStartIndex(
#ifdef __STDC__
			     const char* indexName
#endif
			   );
extern void CDLSfsEndIndex(
#if __STDC__
			   void
#endif
			 );
extern void CDLSfsAddIndexField(
#ifdef __STDC__
				const char* fieldName
#endif
			      );
extern void CDLSfserror(
#ifdef __STDC__
			char* errStr
#endif
		      );
extern int CDLSfsparse(
#if __STDC__
			void
#endif
		      );

#ifdef __cplusplus
}
#endif

extern int CDLSfsCurrentLine;
extern int CDLSfsdebug;
extern FILE* CDLSfsin;
extern int CDLSfsFailed;

/* 
 * Variables that are set by the lex parser and cleared to "default" 
 * by this module:
 */

extern CDLFileType fileType;
extern int duplicates;
extern CDLIndexDir direction;
extern int hasLang;
extern char* langName;
extern int hasACL;
extern char* ACLName;
extern int buildIt;

#endif
