#include <RqsTest.H>
#include <fstream.h>
#include <iostream.h>
#include <string.h>
#include <ctype.h>
#include <stdio.h>
#include <objtran/tranclient.H>
#include <objtran/transaction.H>
#include <objdce/abortreason.H>
#include <stdlib.h>
#include <RqsTest_cdl.H>
#include <RqsTest_cdl_rqs.H>

#include <String.h>

void Print_Data(char* text,rqsTest tp)
{
 FILE *ptr;
 char str[20]; 

 ptr = fopen("out_file","a+");
 fprintf(ptr,"%s",text);
 strcpy(str,tp.strn());
 fprintf(ptr,"\n elem_count: %i \n",(int)tp.elem_count());
 fprintf(ptr," string: %s \n",str);
 fprintf(ptr," long_num: %li \n",tp.longnum());
 fprintf(ptr," real_num: %.2f \n",tp.realnum());
 fprintf(ptr," char: %c \n",tp.ch());
 idl_hyper_int vall = tp.hypernum(); 
 fprintf(ptr," hyperhigh: %li \n",vall.high);
 fprintf(ptr," hyper_low: %u \n",vall.low);
 fprintf(ptr," bytes    : %s \n",tp.bytenum());
 fprintf(ptr," varBytes : %s \n",tp.varbyte());

 for(int j=0;j<3;j++)
   {
     fprintf(ptr," short_arr[%i]: %i \n",j,(int)tp.shortarr(j));
     fprintf(ptr," long_arr [%i]: %li \n",j,tp.longarr(j));
     fprintf(ptr," real_arr [%i]: %.2f \n",j,tp.realarr(j));
     fprintf(ptr," char_arr [%i]: %s \n",j,tp.charr());
     idl_hyper_int vall = tp.hyperarr(j); 
     fprintf(ptr," hyperhigh[%i]: %li \n",j,vall.high);
     fprintf(ptr," hyper_low[%i]: %u \n",j,vall.low);
   }
 fclose(ptr);
}

void Print_Text(char* text)
{
 FILE *ptr;
 
 ptr = fopen("out_file","a+");
 fprintf(ptr,"%s",text);
 fclose(ptr);
}

void Print_Long(unsigned long& len)
{
 FILE *ptr;
 
 ptr = fopen("out_file","a+");
 fprintf(ptr,"%li",len);
 fclose(ptr);
}   

void Print_Hyper(HyperInt work)     
{
 FILE *ptr;

 ptr = fopen("out_file","a+");
 fprintf(ptr,"%s",(char*)work);
 fclose(ptr);
}


void fill_rec(rqsTest& strTx, short el_count)
{
  idl_hyper_int vall = {1L,1L};
  strTx.strn("sample");
  strTx.elem_count(el_count);
  strTx.longnum(13);
  strTx.realnum(2.22);
  strTx.ch('a');
  strTx.hypernum(vall);
 
  unsigned char* val;
  val = new unsigned char[1];
  *val='c';
  strTx.bytenum(val ,(const unsigned)1); 
  strTx.varbyte(val,(const unsigned)1); 

  for(int j=0;j<3;j++)
    {
      strTx.shortarr(j,el_count);
      strTx.longarr(j,13);
      strTx.realarr(j,4.44);
      strTx.charr("bbb"); 
      strTx.hyperarr(j,vall);
   }
      
} 


void Sample::Queue_name(int i)
{
    switch (i)
    {
     case 0:
           response = "One";
           break;
     case 1:
	   response = "Two";
           break;
     case 2:
	   response = "Three";
	   break;
     default: 
           cout<<"Illigal queue number"<<endl;
           break;
     }
  }


void Sample::Create_type()
{ 
  NewTransaction *t;
  rqsTest_YQtype* type;

  strcpy(text,"\n*******************************************\n");
  Print_Text(text);
  strcpy(text,"\n .........CREATE < rqsTest > TYPE....... \n\n");
  Print_Text(text);

  t = new NewTransaction();
  type = new rqsTest_YQtype(server);
  type->Create();
  t->Commit();
  if(t->Aborted())
        printf("Aborted");
  delete t;
  delete type;
}

void Sample::Create_queue()
{
  NewTransaction *t;

  strcpy(text,"\n*******************************************\n");
  Print_Text(text);
  strcpy(text,"\n ........CREATE THREE QUEUE.......\n\n");
  Print_Text(text);

  for(int i = 0; i < 3; i++)
  {
     Queue_name(i);
     q = new rqsTest_YQqueue(response,server);
     t = new NewTransaction();
     q->CreateQueue();
     t->Commit();
     if(t->Aborted())
       printf("Aborted");
     delete t;
     delete q;
  }
}


void Sample::Create_queueset()
{
  List<String> queue_name;
  List<unsigned int> queue_priority;

  String qset_name = "Sample";
  mySet = new rqsTest_YQqueueset(qset_name);  

  NewTransaction *t;

  strcpy(text,"\n*******************************************\n");
  Print_Text(text);
  strcpy(text,"\n ...CREATE  QUEUE  SET WITH TWO QUEUE INSIDE....\n\n");
  Print_Text(text);

  for(int i=0; i<2; i++)
    {
      Queue_name(i);
      queue_name.put(response);
      int pr = i+1;
      queue_priority.put((unsigned)pr);
    } 
  t = new NewTransaction();
  mySet->CreateQueueset(queue_name, queue_priority);
  t->Commit();
  if (t->Aborted())
        {
           String errStr;
           t->GetAbortReason()->Print(errStr);
           cerr << "Call Failed: "<< errStr <<endl;
        }
}


void Sample::Add_queue()
{
  NewTransaction *t;
  unsigned int prior;

  String qset_name = "Sample";
  mySet = new rqsTest_YQqueueset(qset_name);  

  strcpy(text,"\n*******************************************\n");
  Print_Text(text);
  strcpy(text,"\n .....ADD A QUEUE TO THE  QUEUE SET.....\n\n");
  Print_Text(text);

  Queue_name(2);
  prior = 8;
  t = new NewTransaction();
  mySet->InsertQueue(response, prior);
  t->Commit();
  if (t->Aborted())
     {
        String errStr;
        t->GetAbortReason()->Print(errStr);
        cerr << "Call Failed: "<< errStr <<endl;
     }
 
}

void Sample::Change_prior()
{
  NewTransaction *t;
  unsigned int prior;

  String qset_name = "Sample";
  mySet = new rqsTest_YQqueueset(qset_name);  

  strcpy(text,"\n*******************************************\n");
  Print_Text(text);
  strcpy(text,"\n .......SET ALL PRIORITIES TO FIVE...... \n\n");
  Print_Text(text);

  for(int i=0;i<3;i++)
    {
      Queue_name(i);
      prior = 5;  
      t = new NewTransaction();
      mySet->SetQueuePriority(response, prior);
      t->Commit();
           if (t->Aborted())
           {
              String errStr;
              t->GetAbortReason()->Print(errStr);
              cerr << "Call Failed: "<< errStr <<endl;
           }
    }
}


void Sample::RemovePriorities()
{
  NewTransaction *t;
  List<unsigned int> priorA;

  strcpy(text,"\n*******************************************\n");
  Print_Text(text);
  strcpy(text,"\n .......REMOVE UNUSED PRIORITY <1,2,8>...... \n\n");
  Print_Text(text);

  String qset_name = "Sample";
  mySet = new rqsTest_YQqueueset(qset_name);  
  priorA.put(1);
  priorA.put(2);
  priorA.put(8);
  t = new NewTransaction();
  mySet->RemovePriorities(priorA);
  t->Commit();
  if (t->Aborted())
  {
    String errStr;
    t->GetAbortReason()->Print(errStr);
    cerr << "Call Failed: "<< errStr <<endl;
   }
}

void Sample::Inf_Serv_Level()
{
  NewTransaction *t;

  strcpy(text,"\n*******************************************\n");
  Print_Text(text);
  strcpy(text,"\n .........SET INF. SERV. LEVELS........ \n\n");
  Print_Text(text);

  String qset_name = "Sample";
  mySet = new rqsTest_YQqueueset(qset_name);  

  t = new NewTransaction();
  mySet->SetInfiniteServiceLevels();
  t->Commit();
       if (t->Aborted())
       {
              String errStr;
              t->GetAbortReason()->Print(errStr);
              cerr << "Call Failed: "<< errStr <<endl;
       }
}


void Sample::SetServLevels()
{
  NewTransaction *t;
  List<unsigned int> servLev;
  List<unsigned int> priorArr;

  strcpy(text,"\n*******************************************\n");
  Print_Text(text);
  strcpy(text,"\n .....SET ALL SERVICE LEVELES TO THREE..... \n\n");
  Print_Text(text);

  servLev.put(3);
  priorArr.put(5);
  
  String qset_name = "Sample";
  mySet = new rqsTest_YQqueueset(qset_name);  

  t = new NewTransaction();
  mySet->SetServiceLevels(servLev, priorArr);
  t->Commit();
  if (t->Aborted())
     {
       String errStr;
       t->GetAbortReason()->Print(errStr);
       cerr << "Call Failed: "<< errStr <<endl;
      }
}

void Sample::Remove_Queue()
{
  NewTransaction *t;

  String qset_name = "Sample";
  mySet = new rqsTest_YQqueueset(qset_name);  

  strcpy(text,"\n*******************************************\n");
  Print_Text(text);
  strcpy(text,"\n ........REMOVE ALL QUEUES FROM A QSET.... \n\n");
  Print_Text(text);

  for(int i=0; i<3; i++)
    {
       Queue_name(i);
       t = new NewTransaction();
       mySet->RemoveQueue(response);
       t->Commit();
       if (t->Aborted())
       {
              String errStr;
              t->GetAbortReason()->Print(errStr);
              cerr << "Call Failed: "<< errStr <<endl;
       }
     } 
}


void Sample::Enqueue()
{
  YQelementID eid;
  HyperInt amt;
  rqsTest strTx;
  amt = 1L;

  strcpy(text,"\n*******************************************\n");
  Print_Text(text);
  strcpy(text,"\n ....ENQUEUE FIVE ELEMENTS TO ALL(THREE) QUEUES...\n\n");
  Print_Text(text);

  for(int i = 0; i < 3; i++)
  {
     Queue_name(i);
      q = new rqsTest_YQqueue(response,server);
     for(int j=0;j<5;j++)    
      {  
        fill_rec(strTx,(short)j);
        NewTransaction* tran = new NewTransaction();
          q->Enqueue(eid,strTx,amt);
	  if(i==1)   leid.put(eid); 
        tran->Commit();
        if (tran->Aborted())
        {
         String errStr;
         tran->GetAbortReason()->Print(errStr);
         cerr << "Call Failed: "<< errStr <<endl;
        }
        delete tran;
      } 
      unsigned long len;
      HyperInt work;     
      NewTransaction* tran = new NewTransaction();
         q->QStat(len, work);
      tran->Commit();
       if (tran->Aborted())
        {
         String errStr;
         tran->GetAbortReason()->Print(errStr);
         cerr << "Call Failed: "<< errStr <<endl;
        }
     delete tran; 
  
     if(i==0)
       {
        strcpy(text,"\n****** QUEUES   STATISTICS *****\n");
        Print_Text(text);
        strcpy(text,"\n  Queue One_rqsTest \n");
        Print_Text(text);
       }
     if(i==1)
       {
        strcpy(text,"\n\n  Queue Two_rqsTest \n");
        Print_Text(text);
       }
     if(i==2)
       {
        strcpy(text,"\n\n  Queue Three_rqsTest \n");
        Print_Text(text);
       }
     strcpy(text,"\n Length of the queue is: ");
     Print_Text(text);
     Print_Long(len);
     strcpy(text, "\n Work is: ");
     Print_Text(text);
     Print_Hyper(work);

/*     switch (i)
     {
       case 0:
           strcpy(text,"\n-----Query Queue One_rqsTest -------- \n\n");
           Print_Text(text);
           system("rqsadmin query queue One_rqsTest>>out_file"); 
           break;
       case 1:
           strcpy(text,"\n-----Query Queue Two_rqsTest -------- \n\n");
           Print_Text(text);
           system("rqsadmin query queue Two_rqsTest>>out_file");
           break; 
       case 2:
           strcpy(text,"\n-----Query Queue Three_rqsTest -------- \n\n");
           Print_Text(text);
           system("rqsadmin query queue Three_rqsTest>>out_file"); 
           break;
       default:
	   break;
 	 }  */
  }

 
/*  strcpy(text,"\n.......OPERATIONS WITH ELEMENTS ID.......\n");
  Print_Text(text);
  int r = 0;
  while(r!=2)
    {
      Element_Modify(r);
      r++;
    }
  strcpy(text,"\n LIST OF ALL ELEMENTS WHICH HAVE BEEN DELETED: \n");
  Print_Text(text);
  while(leid)
    Element_Delete(); */
}  


void Sample::Dequeue()
{
 HyperInt work;
 YQbase::DeleteOption dltopt;
 rqsTest dst;
 YQelementID eid;

  strcpy(text,"\n*******************************************\n");
  Print_Text(text);
  strcpy(text,"\n DEQUEUE ALL ELEMENTS FROM THE QUEUE <THREE_TEST>\n\n");
  Print_Text(text);

  Queue_name(2); 
  q = new rqsTest_YQqueue(response,server);
  dltopt=YQbase::Delete;
  for(int i=0;i<5;i++)
   {
     NewTransaction* tran = new NewTransaction();
     q->Dequeue(dst, dltopt, eid, 1, work);
     tran->Commit();
     if (tran->Aborted())
       {
         String errStr;
         tran->GetAbortReason()->Print(errStr);
         cerr << "Call Failed: "<< errStr <<endl;
        }
      delete tran;
    }
}


void Sample::Cursor()
{
  YQbase::ElementLockMode elm;
  YQbase::CursorPolicy cp;
  List<HyperInt> WorkList;
  int num_elem;   
  List<rqsTest> ElementList;
  char str[10];
  rqsTest tp;
  char text[80];

  strcpy(text,"\n*******************************************\n");
  Print_Text(text);
  strcpy(text,"\n.............CURSOR............  \n\n");
  Print_Text(text);

  cp = YQbase::TranRepeatability;
  elm = YQbase::WriteLock;
  num_elem = 2;
  Queue_name(1); 
  myCursor= new rqsTest_YQcursor(response, cp, elm, server);
  NewTransaction* tran = new NewTransaction();
    myCursor->Next((const unsigned)num_elem, ElementList, WorkList);     
  if (tran->Aborted())
       {
         String errStr;
         tran->GetAbortReason()->Print(errStr);
         cerr << "Call Failed: "<< errStr <<endl;
        }

  strcpy(text,"\n READ TWO ELEMENTS FROM THE <TWO_rqsTEST> QUEUE \n\n");

  while(ElementList)
  {
    ElementList.get(tp);
    Print_Data(text,tp);
    
    cout<<" D A T A *********"<<endl;
    cout<<tp;

    strcpy(text,"\n .............\n");
   }
   
  strcpy(text,"\n RESET THE CURSOR \n\n");
  Print_Text(text); 
  myCursor->Reset();
  if (tran->Aborted())
       {
         String errStr;
         tran->GetAbortReason()->Print(errStr);
         cerr << "Call Failed: "<< errStr <<endl;
        }
  strcpy(text,"\n READ AN ELEMENT AND ADVANCE THE CURSOR PAST IT \n\n");
  HyperInt Work;
   myCursor->Next(tp, Work);
  tran->Commit();
  if (tran->Aborted())
       {
         String errStr;
         tran->GetAbortReason()->Print(errStr);
         cerr << "Call Failed: "<< errStr <<endl;
        }
  delete tran;
  Print_Data(text,tp);
  }


void Sample::Element_Read(YQelementID eid, YQbase::ElementLockMode elm, Boolean retLock, int flag)
{
  rqsTest data;
  Queue_name(1); 

 if(flag==1)
   strcpy(text,"\n READ THE ELEMENT FROM THE <TWO_rqsTEST> QUEUE \n");
 else
   strcpy(text,"\n READ MODIFIED ELEMENT FROM THE QUEUE <TWO_rqsTEST> \n");

 rqsTest_YQelement myElement(response,"rqsTest",server );
 NewTransaction* tran = new NewTransaction();
    myElement.Read(eid ,elm, retLock, data);
 tran->Commit();
 if (tran->Aborted())
       {
         String errStr;
         tran->GetAbortReason()->Print(errStr);
         cerr << "Call Failed: "<< errStr <<endl;
        }
  delete tran;
  Print_Data(text,data);
}


void Sample::Element_Modify(int r)
{
  Boolean retLock = true;
  YQbase::ElementLockMode elm;
  elm = YQbase::ReadLock;
  rqsTest strTx;
  YQelementID eid;

  leid.get(eid);
  Queue_name(1); 

  Element_Read( eid , elm, retLock, 1);

  rqsTest_YQelement myElement(response,"rqsTest",server );

  fill_rec(strTx,2);
  strTx.strn("modify");
  strTx.elem_count(r);
  strTx.longnum(333);
  for(int j=0;j<3;j++)
    {
      strTx.charr("mmm");
      strTx.shortarr(j,r);
    } 
  NewTransaction* tran = new NewTransaction();  
  myElement.Modify(eid, strTx);
  tran->Commit();
  if (tran->Aborted())
       {
         String errStr;
         tran->GetAbortReason()->Print(errStr);
         cerr << "Call Failed: "<< errStr <<endl;
        }
   delete tran;
   Element_Read( eid , elm, retLock, 0);
}      

  
void Sample::Element_Delete()
{  
  YQbase::DeleteOption delopt;
  delopt = YQbase::Delete;
  rqsTest dst;
  YQelementID eid;

  leid.get(eid);
  strcpy(text,"\n .......................... \n");
  rqsTest_YQelement myElement(response,"rqsTest",server );
  NewTransaction* tran = new NewTransaction();  
      myElement.Delete(eid, delopt, dst);
  tran->Commit();
  if (tran->Aborted())
       {
         String errStr;
         tran->GetAbortReason()->Print(errStr);
         cerr << "Call Failed: "<< errStr <<endl;
        }
  delete tran;
  Print_Data(text,dst);
}

void Sample::Key_Read()
{  
  YQbase::ElementLockMode lockMode;
  lockMode = YQbase::ReadLock;
  List<YQelementID> ids;
  List<rqsTest> values;
  rqsTest_YQkey* k;
  k = new rqsTest_YQkey();
  rqsTest_YQkey::Index keyIndex;
  keyIndex = rqsTest_YQkey::Primary;
  rqsTest key;

  key.realnum(2.22);
  key.longnum(13);
  key.elem_count(1);
  key.ch('a');
  

  NewTransaction* tran = new NewTransaction();  
    k->Read(keyIndex,key,lockMode,32,ids,values);
  tran->Commit();
  if (tran->Aborted())
       {
         String errStr;
         tran->GetAbortReason()->Print(errStr);
         cerr << "Call Failed: "<< errStr <<endl;
        }
  delete tran;
  rqsTest data;
  strcpy(text,"\n....READ BY USING DIFERENT KEYS.... \n");
  Print_Text(text);
  strcpy(text,"\n LIST OF MATCHING ELEMENTS: \n");
  Print_Text(text);   
  strcpy(text,"\n ............................... \n");
  while(values)
    {
      values.get(data);
      Print_Data(text,data);
    }
}


void Sample::Keys_Read()
{
 List<rqsTest_YQkey::Index> keyIndex;
 List<rqsTest> keydata;
 rqsTest key; 
 YQbase::ElementLockMode lockMode;
 lockMode = YQbase::ReadLock;
 List<YQelementID> ids;
 List<rqsTest> values;
 rqsTest_YQkey* k;
 k = new rqsTest_YQkey();

  unsigned char* val;
  val = new unsigned char[1];
  *val='c';

 keyIndex.put(rqsTest_YQkey::Primary);
  key.realnum(2.22);
  key.longnum(13);
  key.elem_count(2);
  key.ch('a'); 
 keydata.put(key);

 keyIndex.put(rqsTest_YQkey::one_fields);
  key.strn("sample");
  key.bytenum(val ,(const unsigned)1); 
 keydata.put(key);

 NewTransaction* tran = new NewTransaction();  
   k->Read(keyIndex,keydata,lockMode,32,ids,values);
  tran->Commit();
  if (tran->Aborted())
       {
         String errStr;
         tran->GetAbortReason()->Print(errStr);
         cerr << "Call Failed: "<< errStr <<endl;
        }
  delete tran;
  rqsTest data;
  strcpy(text,"\n LIST OF MATCHING ELEMENTS FOR CONCAT. KEYS: \n");
  Print_Text(text);   
  strcpy(text,"\n ............................... \n");
  while(values)
    {
      values.get(data);
      Print_Data(text,data);
    }
}

void Admin(int num)
{  
  Sample samp_obj;

   switch (num)
     {
       case 1:
           samp_obj.Create_type();           
           break;
       case 2:
           samp_obj.Create_queue();
           break;
       case 3:
           samp_obj.Create_queueset(); 
           break; 
       case 4:
           samp_obj.Add_queue();
           break; 
       case 5:
           samp_obj.Change_prior();
           break;
       case 6:
           samp_obj.RemovePriorities();
           break; 
       case 7:
           samp_obj.SetServLevels();
           break;
       case 8:
           samp_obj.Inf_Serv_Level();
           break; 
       case 9:
           samp_obj.Remove_Queue(); 
           break; 
       case 10:
           samp_obj.Enqueue();
	   break;
       case 11:
           samp_obj.Dequeue();
           break;
       case 12:
           samp_obj.Cursor();
           break;
       case 13:
           samp_obj.Key_Read();
           break;   
       case 14:
           samp_obj.Keys_Read();
           break;
       default:
	   cout<<"Illigal parameter: "<<endl;
           break;
  }
if (num==1)
  {
    cout<<"      If ENCINA_RQS_SERVER is not set then: "<<endl;
    cout<<"      setenv ENCINA_RQS_SERVER /.:/encina/rqs/test1"<<endl<<endl;
    cout<<"..........Please wait............."<<endl;
  }

if(num==13)
  cout<<"Look for the output file in the file ./out_file"<<endl; 
}



main(int argc,char* argv[])
{
  TranClient client((LoginContext*)0);
  char buff[10];

  strcpy (buff,argv[1]);
  int num = atoi(buff);
  
  if(num==0)
    for(num = 0; num<15; num++)
      Admin(num);
  else Admin(num);  
}  














