#include <objdce/statics.H>
#include <objdce/error.H>
#include <iostream.h>
#include <string.h>
#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <objtran/tranclient.H>
#include <objtran/transaction.H>
#include <objdce/abortreason.H>
#include <memory.h>
#include <math.h>
#include <String.h>
#include <List.h>
#include <Sequential.H>


void Fill_Rec(MyRec& Tx)
{
  addrec  T;
  T.addsh(5);
  T.addstr("addRec");
  Tx.add(T);

 Tx.shrt(2);
 Tx.lng(55);
 Tx.str("test");
 Tx.rl(2.22);
 Tx.ch('a');

  unsigned char* val;
  val = new unsigned char[1];
  *val='c';
  Tx.bytenum(val ,(const unsigned)1);
  Tx.varbyte(val,(const unsigned)1);
  idl_hyper_int vall;
  vall.high = 1L;
  vall.low = 1L;

  for(int j=0;j<3;j++)
    {
      Tx.shortarr(j,2);
      Tx.longarr(j,13);
      Tx.realarr(j,4.44);
      Tx.charr(j,'b');
      Tx.hyperarr(j,vall);
   }
} 


void Exmp::CreateFile()
{
  NewTransaction *t;

  cout<<"**************** CREATE FILE <SequentialTest> ***********"<<endl<<endl;
  t = new NewTransaction(); 
  file.CreateFile("/.:/encina/sfs/main","SequentialTest","lvol_main",3);
  t->Commit();
  if(t->Aborted())
     {
       String errStr;
       t->GetAbortReason()->Print(errStr);
       cerr << "Call Failed: "<< errStr <<endl;
      }
  delete t;
}


void Exmp::OpenFile()
{
  NewTransaction *t;

  t = new NewTransaction();
     file.OpenFile("/.:/encina/sfs/main","SequentialTest",flags);
  t->Commit();
  if(t->Aborted())
     {
           String errStr;
           t->GetAbortReason()->Print(errStr);
           cerr << "Call Failed: "<< errStr <<endl;
      }
  delete t; 
}

void Exmp::Insert()
{
  MyRec Tx;
  MyRec out;
  NewTransaction *t;

  cout<<"**** INSERT THREE RECORDS IN THE FILE <SequentialTest> ****"<<endl;
  flags = 0;
  OpenFile();
 
  for(int i=0; i<3; i++)
  {                     
      Fill_Rec(Tx);
      t = new NewTransaction();  
          file.Insert(Tx);
      t->Commit();
      if (t->Aborted())
        {
           String errStr;
           t->GetAbortReason()->Print(errStr);
           cerr << "Call Failed: "<< errStr <<endl;
        }
      delete t;
      hyperarr[i]=Tx.hypernum();
      cout<<"HYPER HIGH #"<<i<<" IS "<< hyperarr[i].high<<endl;
      cout<<"HYPER LOW #"<<i<<" IS "<< hyperarr[i].low<<endl;
    }  

  CloseFile();
}

void Exmp::DestroyFile()
{
  NewTransaction *t;

  cout<<"********* DESTROY FILE <SequentialTest> ***********"<<endl;
  flags = CDL_NONTRANSACTIONAL_OPEN | CDL_EXCLUSIVE_OPEN;  
  OpenFile();
  t = new NewTransaction();  
     file.DestroyFile();
  t->Commit();
  if (t->Aborted())
     {
        String errStr;
        t->GetAbortReason()->Print(errStr);
        cerr << "Call Failed: "<< errStr <<endl;
      }
  delete t;
}


void Exmp::CloseFile()
{
  NewTransaction *t;

  t = new NewTransaction();  
     file.CloseFile();
  t->Commit();
  if (t->Aborted())
     {
        String errStr;
        t->GetAbortReason()->Print(errStr);
        cerr << "Call Failed: "<< errStr <<endl;
      }
  delete t;
}

void Exmp::EmptyFile()
{
  NewTransaction *t;

  cout<<"******** EMPTY THE FILE <SequentialTest> *********"<<endl;
  flags = CDL_EXCLUSIVE_OPEN | CDL_NONTRANSACTIONAL_OPEN;
  OpenFile();
  t = new NewTransaction();  
     file.EmptyFile();
  t->Commit();
  if (t->Aborted())
     {
        String errStr;
        t->GetAbortReason()->Print(errStr);
        cerr << "Call Failed: "<< errStr <<endl;
      }
  delete t;
  CloseFile();
}

void Exmp::InsertList()
{
  List<MyRec> list;
  MyRec Tx;
  NewTransaction *t;

  cout<<"**** INSERT LIST OF A THREE RECORDS ****"<<endl; 
  flags = 0;
  OpenFile();
  for(int i=0; i<3; i++)
    {
      Fill_Rec(Tx);
      list.put(Tx);
    }
  t = new NewTransaction();  
     file.InsertList(list);
  t->Commit();
  if (t->Aborted())
  {
     String errStr;
     t->GetAbortReason()->Print(errStr);
     cerr << "Call Failed: "<< errStr <<endl;
   }
   delete t;
   CloseFile();
}


void Exmp::ReadUnique()
{
  MyRec outTx;
  NewTransaction *t;
  MyRec key;
  CDLReadLock lock = READ;

  cout<<"*************   READ UNIQUE   ***********"<<endl;
  cout<<"*** Read a record with a KEY<key.lng = 6 and key.shrt = 1> ***"<<endl;
  cout<<endl;

/******/
  hyperarr[0].high = 0;
  hyperarr[0].low = 9175040;

     cout<<"HYPER HIGH "<<" IS "<< hyperarr[0].high<<endl;
     cout<<"HYPER LOW "<<" IS "<< hyperarr[0].low<<endl;

  key.hypernum(hyperarr[0]);
  flags = 0;
  cout<<"BEFORE OPEN"<<endl;
  OpenFile();
  cout<<"AFTER OPEN"<<endl;
  t = new NewTransaction();  
     file.ReadUnique(lock, SequentialTest::PRIMARY , key, outTx);
  t->Commit();
  if (t->Aborted())
  {
     String errStr;
     t->GetAbortReason()->Print(errStr);
     cerr << "Call Failed: "<< errStr <<endl;
  }
  delete t;
  cout<<outTx<<endl; 
  CloseFile();
}  


void Exmp::DeleteUnique()
{
  NewTransaction *t;
  MyRec key;

  cout<<"*****************   DELETE UNIQUE   ***************"<<endl;
cout<<"*** Delete a record with a KEY<key.shrt = 2 and key.lng = 7> ***"<<endl;
  cout<<endl;

  hyperarr[0].high = 0;
  hyperarr[0].low = 0;

  key.hypernum(hyperarr[0]);
  flags = 0;
  OpenFile();
  t = new NewTransaction();  
     file.DeleteUnique(SequentialTest::PRIMARY ,key);
  t->Commit();
  if (t->Aborted())
  {
     String errStr;
     t->GetAbortReason()->Print(errStr);
     cerr << "Call Failed: "<< errStr <<endl;
  }
  delete t;
  CloseFile(); 
}  


void Exmp::UpdateUnique()
{
  MyRec newRec;
  NewTransaction *t;
  MyRec key;

  cout<<"*** Update a record with a KEY<key.lng=6; key.shrt=1> ***"<<endl;
  cout<<"*** String in the first record has to be <modify> ***"<<endl; 

  hyperarr[0].high = 0;
  hyperarr[0].low = 0;

  key.hypernum(hyperarr[0]);
  Fill_Rec(newRec);
  newRec.str("modify");
  flags = 0;
  OpenFile();
  t = new NewTransaction();  
     file.UpdateUnique(SequentialTest::PRIMARY , key, newRec);
  t->Commit();
  if (t->Aborted())
  {
     String errStr;
     t->GetAbortReason()->Print(errStr);
     cerr << "Call Failed: "<< errStr <<endl;
  }
  delete t;
  CloseFile();   
}  

void Exmp::ReadAll()
{
  NewTransaction *t;
  CDLReadLock lock = READ;
  List<MyRec> list;
  CDLIndexDir dir = FORWARDS;

  cout<<"**** READ ALL RECORDS IN THE FILE <SequentialTest> ****"<<endl<<endl;
  flags = 0;
  OpenFile();
  t = new NewTransaction();  
     file.ReadAll(lock, SequentialTest::PRIMARY, 0, 0, dir, list);
  t->Commit();
  if (t->Aborted())
  {
     String errStr;
     t->GetAbortReason()->Print(errStr);
     cerr << "Call Failed: "<< errStr <<endl;
  }
  delete t;
  MyRec Tx;
  while(list)
    {
      list.get(Tx);
      cout<<Tx<<endl;
    }
  CloseFile();
}  


void Exmp::DeleteAll()
{
  NewTransaction *t;

  cout<<"***** DELETE ALL RECORDS ****"<<endl;
  flags = 0;
  OpenFile();
  t = new NewTransaction();  
     file.DeleteAll(SequentialTest::PRIMARY, 0, 0);
  t->Commit();
  if (t->Aborted())
  {
     String errStr;
     t->GetAbortReason()->Print(errStr);
     cerr << "Call Failed: "<< errStr <<endl;
  }
  delete t;
  CloseFile();
}  


void Exmp::DeleteAllkey()
{
  NewTransaction *t;

  MyRec key;
 
cout<<"***** DELETE ALL RECORDS WITH A KEY< key.lng=6; key.shrt=1> ****"<<endl;
  key.hypernum(hyperarr[1]);
  flags = 0;
  OpenFile();
  t = new NewTransaction();  
     file.DeleteAll(SequentialTest::PRIMARY, key);
  t->Commit();
  if (t->Aborted())
  {
     String errStr;
     t->GetAbortReason()->Print(errStr);
     cerr << "Call Failed: "<< errStr <<endl;
  }
  delete t;
  CloseFile(); 
}  


void Exmp::Select()
{
  MyRec start;
  MyRec end; 
  
  hyperarr[0].high = 0;
  hyperarr[0].low = 0;
 
  start.hypernum(hyperarr[0]);

  end.lng(1);

  CDLIndexDir dir = FORWARDS;
  
  file.Select(SequentialTest::PRIMARY, &start, &end, dir); 
}  


void Exmp::ReadCurrent(int i)
{
  NewTransaction *t;
  CDLReadLock lock = READ;
  CDLRecordDir dir = NEXT;
  MyRec outRec;

  flags = 0;
  OpenFile();
  t = new NewTransaction();
  if(i==0)   {
               Select();  
               cout<<"READ A CURRENT RECORD WITH A PRIMARY INDEX"<<endl;
              }
     else  {
             Select_sec();
             cout<<"READ CURRENT RECORD WITH A SECONDORY INDEX"<<endl;
           }
     file.ReadCurrent(lock, dir, outRec);
     cout<<outRec<<endl;
  t->Commit();
  if (t->Aborted())
  {
     String errStr;
     t->GetAbortReason()->Print(errStr);
     cerr << "Call Failed: "<< errStr <<endl;
  }
  delete t;
  CloseFile();
}  


void Exmp::DeleteCurrent()
{
  NewTransaction *t;
  CDLRecordDir dir = NEXT;

  cout<<"**** DELETE CURRENT RECORD ****"<<endl;
  flags = 0;
  OpenFile();
  t = new NewTransaction();
     Select();  
     file.DeleteCurrent(dir);
  t->Commit();
  if (t->Aborted())
  {
     String errStr;
     t->GetAbortReason()->Print(errStr);
     cerr << "Call Failed: "<< errStr <<endl;
  }
  delete t;
  CloseFile();
}  

void Exmp::UpdateCurrent()
{
  NewTransaction *t;
  CDLRecordDir dir = NEXT;
  MyRec newRec;

  cout<<"**** UPDATE CURRENT RECORD ****"<<endl;
  cout<<"**** String has to be <update> ****"<<endl;
  Fill_Rec(newRec);
  newRec.str("update");
  flags = 0;
  OpenFile();
  t = new NewTransaction();
     Select();  
     file.UpdateCurrent(dir, newRec);
  t->Commit();
  if (t->Aborted())
  {
     String errStr;
     t->GetAbortReason()->Print(errStr);
     cerr << "Call Failed: "<< errStr <<endl;
  }
  delete t;
  CloseFile();
}  


void Exmp::Modify_fld()
{
  NewTransaction *t;

  MyRec outRec;
  MyRec key;
  double n = 44.4;

  cout<<"**** MODIFY FIELED double ****"<<endl;
  cout<<"**** Double has to be equal to 44.4 ****"<<endl;
  key.hypernum(hyperarr[1]);
  flags = 0;
  OpenFile();
  t = new NewTransaction();
     file.Modify_rl(SequentialTest::PRIMARY, key, n, outRec);
  t->Commit();
  if (t->Aborted())
  {
     String errStr;
     t->GetAbortReason()->Print(errStr);
     cerr << "Call Failed: "<< errStr <<endl;
  }
  delete t;
  CloseFile();  
}  


void Exmp::Increment_fld()
{
  NewTransaction *t;

  MyRec outRec;
  MyRec key;
  double n = 3.3;

  cout<<"**** INCREMENT FIELED double by 3.3 ****"<<endl;
  cout<<"**** Double has to be equal to 47.7 ****"<<endl;
  key.hypernum(hyperarr[1]);
  flags = 0;
  OpenFile();
  t = new NewTransaction();
     file.Increment_rl(SequentialTest::PRIMARY, key, n, outRec);
  t->Commit();
  if (t->Aborted())
  {
     String errStr;
     t->GetAbortReason()->Print(errStr);
     cerr << "Call Failed: "<< errStr <<endl;
  }
  delete t;
  CloseFile(); 
}  


void Exmp::DeactivateIndex()
{
  NewTransaction *t;

  cout<<"**** DEACTIVATE  INDEX ****"<<endl;

  flags = CDL_EXCLUSIVE_OPEN | CDL_NONTRANSACTIONAL_OPEN;
  OpenFile();
  t = new NewTransaction();
    file.DeactivateIndex(SequentialTest::ONE_FIELDS);
  t->Commit();
  if (t->Aborted())
  {
     String errStr;
     t->GetAbortReason()->Print(errStr);
     cerr << "Call Failed: "<< errStr <<endl;
  }
  delete t;
  CloseFile();
}  

void Exmp::ActivateIndex()
{
  NewTransaction *t;

  cout<<"**** ACTIVATE  INDEX ****"<<endl;

  flags = CDL_EXCLUSIVE_OPEN | CDL_NONTRANSACTIONAL_OPEN;
  OpenFile();
  t = new NewTransaction();
    file.ActivateIndex(SequentialTest::ONE_FIELDS,"lvol_main" );
  t->Commit();
  if (t->Aborted())
  {
     String errStr;
     t->GetAbortReason()->Print(errStr);
     cerr << "Call Failed: "<< errStr <<endl;
  }
  delete t;
  CloseFile();
}  


void Exmp::Select_sec()
{
  MyRec start;
  MyRec end; 
  
  start.str("modify");
  end.str("test");


  CDLIndexDir dir = FORWARDS;
  
  file.Select(SequentialTest::ONE_FIELDS, &start, &end, dir);
}  

void Admin(int num)
{
  Exmp exmp_obj;

  switch (num)
     {
       case 1:
           exmp_obj.CreateFile();
           break;
       case 2:
           exmp_obj.Insert();
           break;
       case 3:
           exmp_obj.DestroyFile();
           break;
       case 4:
           exmp_obj.EmptyFile();
           break;
       case 5:
           exmp_obj.InsertList();
           break;
       case 6:
           exmp_obj.UpdateUnique();
           break;
       case 7:
           exmp_obj.ReadUnique();
           break;  
       case 8:
           exmp_obj.DeleteUnique();
           break;
       case 9:
           exmp_obj.ReadAll();
           break; 
       case 10:
           exmp_obj.DeleteAll();
           break; 
       case 11:
           exmp_obj.DeleteAllkey();
           break; 
       case 12:
           exmp_obj.ReadCurrent(0);
           break;
       case 13:
           exmp_obj.DeleteCurrent();
           break;
       case 14:
           exmp_obj.UpdateCurrent();
           break;
       case 15:
           exmp_obj.Modify_fld();
           break;
       case 16:
           exmp_obj.Increment_fld();
           break;
       case 17:
           exmp_obj.ReadCurrent(1);
           break;
       case 18:
           exmp_obj.DeactivateIndex();
           break;
       case 19:
           exmp_obj.ActivateIndex();
           break;
       default:
           cout<<"Illigal parameter: "<< num <<endl;
           break;
     }
}


main(int argc, char** argv)
{
  TranClient client((LoginContext*)0);
  char buff[10];

  strcpy (buff,argv[1]);
  int num = atoi(buff);

  if (num == 0)
    for(num = 0; num<5; num++)
      Admin(num);
  else Admin(num); 
}






