    /*********************************************************************
    Copyright (C) 1993 by Citibank, N.A., all rights reserved.

    Permission to use, copy, modify and distribute this software and its 
    documentation for any purpose and without fee, except possible 
    redistribution costs, is hereby granted, provided that (1) the above 
    copyright notice appears in all copies and (2) both that copyright-
    notice and this permission-notice appear in supporting documentation and 
    (3) the name of Citibank, N.A. is not used in advertising or publicity 
    pertaining to distribution of the software without specific and written 
    prior permission of Citibank, N.A.

    The Software is provided "as is."  Citibank, N.A. disclaims all 
    warranties, express or implied, including but not limited to warranties 
    of suitability, merchantability and fitness for any purpose.  In no 
    event shall Citibank, N.A. be responsible for any loss of use, data or 
    profit or for any other special, indirect, incidental or consequential 
    damages, neither in an action of contract nor in an action of tort, 
    arising out of or in connection with the use or performance of this 
    software.
    *********************************************************************/


#include <cdl/rfsutil.H>
const char * const FieldTypeToString(const rqs_fieldType_t i)
    {
	char * retval;
	switch (i)
	    {
		default:
		    retval = "UNKNOWN FIELD TYPE";
		    break;
		case rqs_unsignedInt16:
		    retval = "unsignedInt16";
		    break;
		case rqs_signedInt16:
		    retval = "signedInt16";
		    break;
		case rqs_unsignedInt32:
		    retval = "unsignedInt32";
		    break;
		case rqs_signedInt32:
		    retval = "signedInt32";
		    break;
		case rqs_unsignedInt64:
		    retval = "unsignedInt64";
		    break;
		case rqs_signedInt64:
		    retval = "signedInt64";
		    break;
		case rqs_float:
		    retval = "float";
		    break;
		case rqs_double:
		    retval = "double";
		    break;
		case rqs_string:
		    retval = "string";
		    break;
		case rqs_nlsString:
		    retval = "nlsString";
		    break;
		case rqs_byteArray:
		    retval = "byteArray";
		    break;
		case rqs_varLenByteArray:
		    retval = "varLenByteArray";
		    break;
		case rqs_shortVarLenByteArray:
		    retval = "shortVarLenByteArray";
		    break;
		case rqs_timestamp:
		    retval = "timestamp";
		    break;
		case rqs_decimal:
		    retval = "decimal";
		    break;
	    }
	return(retval);
    }
ostream & operator <<(ostream &o, const rqs_recordFieldSpec_t & rfs)
    {
	o << "fieldName:\"" << rfs.fieldName << "\"" << endl 
	<< "fieldType:\"" << rfs.fieldType << "\"\t" << 
	FieldTypeToString(rfs.fieldType) << endl 
	<< "fieldSize:" << rfs.fieldSize << endl 
	<< "collatingLanguage:\"" << rfs.collatingLanguage << "\"" << endl;
	return o;
    }
rqs_recordFieldSpec_t & Assign(	rqs_recordFieldSpec_t & p0, 
			        const String & fn, 
				const rqs_fieldType_t & ft, 
				const unsigned long & fs, 
				const String & cl)
    {
	Destroy(p0);
	p0.fieldName = new char[fn.length()+1];
	strcpy(p0.fieldName, fn);
	p0.fieldType = ft;
	p0.fieldSize = fs;
	p0.collatingLanguage = new char[cl.length()+1];
	strcpy(p0.collatingLanguage, cl);
	return(p0);
    }
rqs_recordFieldSpec_t & Assign(rqs_recordFieldSpec_t & p0, 
			       const rqs_recordFieldSpec_t & p1)
    {
	Destroy(p0);
	p0.fieldName = new char[strlen(p1.fieldName) + 1];
	strcpy(p0.fieldName, p1.fieldName);
	p0.collatingLanguage = new char [strlen(p1.collatingLanguage) + 1];
	strcpy(p0.collatingLanguage, p1.collatingLanguage);
	p0.fieldType = p1.fieldType;
	p0.fieldSize = p1.fieldSize;
	return(p0);
    }
rqs_recordFieldSpec_t & Destroy(rqs_recordFieldSpec_t & p0)
    {
	if (p0.fieldName)
	    delete [] p0.fieldName;
	if (p0.collatingLanguage)
	    delete [] p0.collatingLanguage;
	p0.fieldName = 0;
	p0.collatingLanguage = 0;
	p0.fieldType = (rqs_fieldType_t)-1;
	p0.fieldSize = 0;
	return(p0);
    }
